b0eaf6cd252cb073abc10e39b9045839bb1b0d42
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2020 Cisco and/or its affiliates.
2 # Copyright (c) 2020 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install virtualenv==20.0.20 || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
197     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
198     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
199     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
200     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
201     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
202     #   The name is chosen to match what ci-management expects.
203     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
204     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
205     # Directories created if not present:
206     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
207     # Functions called:
208     # - die - Print to stderr and exit.
209
210     set -exuo pipefail
211
212     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
213         die "Some error during locating of this source file."
214     }
215     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
216         die "Some error during dirname call."
217     }
218     # Current working directory could be in a different repo, e.g. VPP.
219     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
220     relative_csit_dir=$(git rev-parse --show-toplevel) || {
221         die "Git rev-parse failed."
222     }
223     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
224     popd || die "Popd failed."
225     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
226         die "Readlink failed."
227     }
228     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
229         die "Readlink failed."
230     }
231     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
232         die "Readlink failed."
233     }
234     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
235         die "Readlink failed."
236     }
237     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
238         die "Readlink failed."
239     }
240     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
241         die "Readlink failed."
242     }
243
244     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
245         die "Readlink failed."
246     }
247     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
248     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
249         die "Readlink failed."
250     }
251     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
252     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
253         die "Readlink failed."
254     }
255     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
256 }
257
258
259 function compose_pybot_arguments () {
260
261     # Variables read:
262     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
263     # - DUT - CSIT test/ subdirectory, set while processing tags.
264     # - TAGS - Array variable holding selected tag boolean expressions.
265     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
266     # - TEST_CODE - The test selection string from environment or argument.
267     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
268     # Variables set:
269     # - PYBOT_ARGS - String holding part of all arguments for pybot.
270     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
271
272     set -exuo pipefail
273
274     # No explicit check needed with "set -u".
275     PYBOT_ARGS=("--loglevel" "TRACE")
276     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
277
278     case "${TEST_CODE}" in
279         *"device"*)
280             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
281             ;;
282         *"perf"*)
283             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
284             ;;
285         *)
286             die "Unknown specification: ${TEST_CODE}"
287     esac
288
289     EXPANDED_TAGS=()
290     for tag in "${TAGS[@]}"; do
291         if [[ ${tag} == "!"* ]]; then
292             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
293         else
294             if [[ ${SELECTION_MODE} == "--test" ]]; then
295                 EXPANDED_TAGS+=("--test" "${tag}")
296             else
297                 EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
298             fi
299         fi
300     done
301
302     if [[ ${SELECTION_MODE} == "--test" ]]; then
303         EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}")
304     fi
305 }
306
307
308 function deactivate_docker_topology () {
309
310     # Deactivate virtual vpp-device topology by removing containers.
311     #
312     # Variables read:
313     # - NODENESS - Node multiplicity of desired testbed.
314     # - FLAVOR - Node flavor string, usually describing the processor.
315
316     set -exuo pipefail
317
318     case_text="${NODENESS}_${FLAVOR}"
319     case "${case_text}" in
320         "1n_skx" | "1n_tx2")
321             ssh="ssh root@172.17.0.1 -p 6022"
322             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
323             # The "declare -f" output is long and boring.
324             set +x
325             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
326                 die "Topology cleanup via shim-dcr failed!"
327             }
328             set -x
329             ;;
330         "1n_vbox")
331             enter_mutex || die
332             clean_environment || {
333                 die "Topology cleanup locally failed!"
334             }
335             exit_mutex || die
336             ;;
337         *)
338             die "Unknown specification: ${case_text}!"
339     esac
340 }
341
342
343 function die () {
344
345     # Print the message to standard error end exit with error code specified
346     # by the second argument.
347     #
348     # Hardcoded values:
349     # - The default error message.
350     # Arguments:
351     # - ${1} - The whole error message, be sure to quote. Optional
352     # - ${2} - the code to exit with, default: 1.
353
354     set -x
355     set +eu
356     warn "${1:-Unspecified run-time error occurred!}"
357     exit "${2:-1}"
358 }
359
360
361 function die_on_pybot_error () {
362
363     # Source this fragment if you want to abort on any failed test case.
364     #
365     # Variables read:
366     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
367     # Functions called:
368     # - die - Print to stderr and exit.
369
370     set -exuo pipefail
371
372     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
373         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
374     fi
375 }
376
377
378 function generate_tests () {
379
380     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
381     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
382     # The generation is done by executing any *.py executable
383     # within any subdirectory after copying.
384
385     # This is a separate function, because this code is called
386     # both by autogen checker and entries calling run_pybot.
387
388     # Directories read:
389     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
390     # Directories replaced:
391     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
392
393     set -exuo pipefail
394
395     rm -rf "${GENERATED_DIR}/tests" || die
396     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
397     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
398     cmd_line+=("-executable" "-name" "*.py")
399     # We sort the directories, so log output can be compared between runs.
400     file_list=$("${cmd_line[@]}" | sort) || die
401
402     for gen in ${file_list}; do
403         directory="$(dirname "${gen}")" || die
404         filename="$(basename "${gen}")" || die
405         pushd "${directory}" || die
406         ./"${filename}" || die
407         popd || die
408     done
409 }
410
411
412 function get_test_code () {
413
414     # Arguments:
415     # - ${1} - Optional, argument of entry script (or empty as unset).
416     #   Test code value to override job name from environment.
417     # Variables read:
418     # - JOB_NAME - String affecting test selection, default if not argument.
419     # Variables set:
420     # - TEST_CODE - The test selection string from environment or argument.
421     # - NODENESS - Node multiplicity of desired testbed.
422     # - FLAVOR - Node flavor string, usually describing the processor.
423
424     set -exuo pipefail
425
426     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
427     if [[ -z "${TEST_CODE}" ]]; then
428         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
429     fi
430
431     case "${TEST_CODE}" in
432         *"1n-vbox"*)
433             NODENESS="1n"
434             FLAVOR="vbox"
435             ;;
436         *"1n-skx"*)
437             NODENESS="1n"
438             FLAVOR="skx"
439             ;;
440        *"1n-tx2"*)
441             NODENESS="1n"
442             FLAVOR="tx2"
443             ;;
444         *"2n-skx"*)
445             NODENESS="2n"
446             FLAVOR="skx"
447             ;;
448         *"2n-zn2"*)
449             NODENESS="2n"
450             FLAVOR="zn2"
451             ;;
452         *"3n-skx"*)
453             NODENESS="3n"
454             FLAVOR="skx"
455             ;;
456         *"2n-clx"*)
457             NODENESS="2n"
458             FLAVOR="clx"
459             ;;
460         *"2n-dnv"*)
461             NODENESS="2n"
462             FLAVOR="dnv"
463             ;;
464         *"3n-dnv"*)
465             NODENESS="3n"
466             FLAVOR="dnv"
467             ;;
468         *"2n-tx2"*)
469             NODENESS="2n"
470             FLAVOR="tx2"
471             ;;
472         *"3n-tsh"*)
473             NODENESS="3n"
474             FLAVOR="tsh"
475             ;;
476         *)
477             # Fallback to 3-node Haswell by default (backward compatibility)
478             NODENESS="3n"
479             FLAVOR="hsw"
480             ;;
481     esac
482 }
483
484
485 function get_test_tag_string () {
486
487     # Variables read:
488     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
489     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
490     # - TEST_CODE - The test selection string from environment or argument.
491     # Variables set:
492     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
493     #   May be empty, or even not set on event types not adding comment.
494
495     # TODO: ci-management scripts no longer need to perform this.
496
497     set -exuo pipefail
498
499     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
500         case "${TEST_CODE}" in
501             *"device"*)
502                 trigger="devicetest"
503                 ;;
504             *"perf"*)
505                 trigger="perftest"
506                 ;;
507             *)
508                 die "Unknown specification: ${TEST_CODE}"
509         esac
510         # Ignore lines not containing the trigger word.
511         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
512         # The vpp-csit triggers trail stuff we are not interested in.
513         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
514         # (except relying on \s whitespace, \S non-whitespace and . both).
515         # The last string is concatenated, only the middle part is expanded.
516         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
517         # On parsing error, TEST_TAG_STRING probably stays empty.
518         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
519         if [[ -z "${TEST_TAG_STRING-}" ]]; then
520             # Probably we got a base64 encoded comment.
521             comment=$(base64 --decode <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
522             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
523             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
524         fi
525         if [[ -n "${TEST_TAG_STRING-}" ]]; then
526             test_tag_array=(${TEST_TAG_STRING})
527             if [[ "${test_tag_array[0]}" == "icl" ]]; then
528                 export GRAPH_NODE_VARIANT="icl"
529                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
530             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
531                 export GRAPH_NODE_VARIANT="skx"
532                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
533             elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
534                 export GRAPH_NODE_VARIANT="hsw"
535                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
536             fi
537         fi
538     fi
539 }
540
541
542 function installed () {
543
544     # Check if the given utility is installed. Fail if not installed.
545     #
546     # Duplicate of common.sh function, as this file is also used standalone.
547     #
548     # Arguments:
549     # - ${1} - Utility to check.
550     # Returns:
551     # - 0 - If command is installed.
552     # - 1 - If command is not installed.
553
554     set -exuo pipefail
555
556     command -v "${1}"
557 }
558
559
560 function move_archives () {
561
562     # Move archive directory to top of workspace, if not already there.
563     #
564     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
565     # but in some jobs CSIT_DIR is not same as WORKSPACE
566     # (e.g. under VPP_DIR). To simplify ci-management settings,
567     # we want to move the data to the top. We do not want simple copy,
568     # as ci-management is eager with recursive search.
569     #
570     # As some scripts may call this function multiple times,
571     # the actual implementation use copying and deletion,
572     # so the workspace gets "union" of contents (except overwrites on conflict).
573     # The consequence is empty ARCHIVE_DIR remaining after this call.
574     #
575     # As the source directory is emptied,
576     # the check for dirs being different is essential.
577     #
578     # Variables read:
579     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
580     #   Can be unset, then it speeds up manual testing.
581     # - ARCHIVE_DIR - Path to directory with content to be moved.
582     # Directories updated:
583     # - ${WORKSPACE}/archives/ - Created if does not exist.
584     #   Content of ${ARCHIVE_DIR}/ is moved.
585     # Functions called:
586     # - die - Print to stderr and exit.
587
588     set -exuo pipefail
589
590     if [[ -n "${WORKSPACE-}" ]]; then
591         target=$(readlink -f "${WORKSPACE}/archives")
592         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
593             mkdir -p "${target}" || die "Archives dir create failed."
594             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
595             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
596         fi
597     fi
598 }
599
600
601 function reserve_and_cleanup_testbed () {
602
603     # Reserve physical testbed, perform cleanup, register trap to unreserve.
604     # When cleanup fails, remove from topologies and keep retrying
605     # until all topologies are removed.
606     #
607     # Variables read:
608     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
609     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
610     # - BUILD_TAG - Any string suitable as filename, identifying
611     #   test run executing this function. May be unset.
612     # Variables set:
613     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
614     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
615     # Functions called:
616     # - die - Print to stderr and exit.
617     # - ansible_playbook - Perform an action using ansible, see ansible.sh
618     # Traps registered:
619     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
620
621     set -exuo pipefail
622
623     while true; do
624         for topo in "${TOPOLOGIES[@]}"; do
625             set +e
626             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
627             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
628             python3 "${scrpt}" "${opts[@]}"
629             result="$?"
630             set -e
631             if [[ "${result}" == "0" ]]; then
632                 # Trap unreservation before cleanup check,
633                 # so multiple jobs showing failed cleanup improve chances
634                 # of humans to notice and fix.
635                 WORKING_TOPOLOGY="${topo}"
636                 echo "Reserved: ${WORKING_TOPOLOGY}"
637                 trap "untrap_and_unreserve_testbed" EXIT || {
638                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
639                     untrap_and_unreserve_testbed "${message}" || {
640                         die "Teardown should have died, not failed."
641                     }
642                     die "Trap attempt failed, unreserve succeeded. Aborting."
643                 }
644                 # Cleanup + calibration checks.
645                 set +e
646                 ansible_playbook "cleanup, calibration"
647                 result="$?"
648                 set -e
649                 if [[ "${result}" == "0" ]]; then
650                     break
651                 fi
652                 warn "Testbed cleanup failed: ${topo}"
653                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
654             fi
655             # Else testbed is accessible but currently reserved, moving on.
656         done
657
658         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
659             # Exit the infinite while loop if we made a reservation.
660             warn "Reservation and cleanup successful."
661             break
662         fi
663
664         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
665             die "Run out of operational testbeds!"
666         fi
667
668         # Wait ~3minutes before next try.
669         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
670             die "Sleep time calculation failed."
671         }
672         echo "Sleeping ${sleep_time}"
673         sleep "${sleep_time}" || die "Sleep failed."
674     done
675 }
676
677
678 function run_pybot () {
679
680     # Run pybot with options based on input variables. Create output_info.xml
681     #
682     # Variables read:
683     # - CSIT_DIR - Path to existing root of local CSIT git repository.
684     # - ARCHIVE_DIR - Path to store robot result files in.
685     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
686     # - GENERATED_DIR - Tests are assumed to be generated under there.
687     # Variables set:
688     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
689     # Functions called:
690     # - die - Print to stderr and exit.
691
692     set -exuo pipefail
693
694     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
695     all_options+=("--noncritical" "EXPECTED_FAILING")
696     all_options+=("${EXPANDED_TAGS[@]}")
697
698     pushd "${CSIT_DIR}" || die "Change directory operation failed."
699     set +e
700     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
701     PYBOT_EXIT_STATUS="$?"
702     set -e
703
704     # Generate INFO level output_info.xml for post-processing.
705     all_options=("--loglevel" "INFO")
706     all_options+=("--log" "none")
707     all_options+=("--report" "none")
708     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
709     all_options+=("${ARCHIVE_DIR}/output.xml")
710     rebot "${all_options[@]}" || true
711     popd || die "Change directory operation failed."
712 }
713
714
715 function select_arch_os () {
716
717     # Set variables affected by local CPU architecture and operating system.
718     #
719     # Variables set:
720     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
721     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
722     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
723
724     set -exuo pipefail
725
726     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
727         die "Get OS release failed."
728     }
729
730     case "${os_id}" in
731         "ubuntu"*)
732             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
733             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
734             PKG_SUFFIX="deb"
735             ;;
736         "centos"*)
737             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
738             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
739             PKG_SUFFIX="rpm"
740             ;;
741         *)
742             die "Unable to identify distro or os from ${os_id}"
743             ;;
744     esac
745
746     arch=$(uname -m) || {
747         die "Get CPU architecture failed."
748     }
749
750     case "${arch}" in
751         "aarch64")
752             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
753             ;;
754         *)
755             ;;
756     esac
757 }
758
759
760 function select_tags () {
761
762     # Variables read:
763     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
764     # - TEST_CODE - String affecting test selection, usually jenkins job name.
765     # - DUT - CSIT test/ subdirectory, set while processing tags.
766     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
767     #   Can be unset.
768     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
769     # - BASH_FUNCTION_DIR - Directory with input files to process.
770     # Variables set:
771     # - TAGS - Array of processed tag boolean expressions.
772     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
773
774     set -exuo pipefail
775
776     # NIC SELECTION
777     start_pattern='^  TG:'
778     end_pattern='^ \? \?[A-Za-z0-9]\+:'
779     # Remove the TG section from topology file
780     sed_command="/${start_pattern}/,/${end_pattern}/d"
781     # All topologies DUT NICs
782     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
783                 | grep -hoP "model: \K.*" | sort -u)
784     # Selected topology DUT NICs
785     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
786                | grep -hoP "model: \K.*" | sort -u)
787     # All topologies DUT NICs - Selected topology DUT NICs
788     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
789         die "Computation of excluded NICs failed."
790     }
791
792     # Select default NIC tag.
793     case "${TEST_CODE}" in
794         *"3n-dnv"* | *"2n-dnv"*)
795             default_nic="nic_intel-x553"
796             ;;
797         *"3n-tsh"*)
798             default_nic="nic_intel-x520-da2"
799             ;;
800         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
801             default_nic="nic_intel-xxv710"
802             ;;
803         *"3n-hsw"* | *"2n-tx2"* | *"mrr-daily-master")
804             default_nic="nic_intel-xl710"
805             ;;
806         *)
807             default_nic="nic_intel-x710"
808             ;;
809     esac
810
811     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
812     awk_nics_sub_cmd=""
813     awk_nics_sub_cmd+='gsub("xxv710","25ge2p1xxv710");'
814     awk_nics_sub_cmd+='gsub("x710","10ge2p1x710");'
815     awk_nics_sub_cmd+='gsub("xl710","40ge2p1xl710");'
816     awk_nics_sub_cmd+='gsub("x520-da2","10ge2p1x520");'
817     awk_nics_sub_cmd+='gsub("x553","10ge2p1x553");'
818     awk_nics_sub_cmd+='gsub("cx556a","10ge2p1cx556a");'
819     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
820     awk_nics_sub_cmd+='gsub("vic1385","10ge2p1vic1385");'
821     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
822     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
823     awk_nics_sub_cmd+='else drv="";'
824     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-"$1"-" drv $11"-"$5'
825
826     # Tag file directory shorthand.
827     tfd="${JOB_SPECS_DIR}"
828     case "${TEST_CODE}" in
829         # Select specific performance tests based on jenkins job type variable.
830         *"ndrpdr-weekly"* )
831             readarray -t test_tag_array <<< $(grep -v "#" \
832                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
833                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
834             SELECTION_MODE="--test"
835             ;;
836         *"mrr-daily"* )
837             readarray -t test_tag_array <<< $(grep -v "#" \
838                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
839                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
840             SELECTION_MODE="--test"
841             ;;
842         *"mrr-weekly"* )
843             readarray -t test_tag_array <<< $(grep -v "#" \
844                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
845                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
846             SELECTION_MODE="--test"
847             ;;
848         *"report-iterative"* )
849             test_sets=(${TEST_TAG_STRING//:/ })
850             # Run only one test set per run
851             report_file=${test_sets[0]}.md
852             readarray -t test_tag_array <<< $(grep -v "#" \
853                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
854                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
855             SELECTION_MODE="--test"
856             ;;
857         *"report-coverage"* )
858             test_sets=(${TEST_TAG_STRING//:/ })
859             # Run only one test set per run
860             report_file=${test_sets[0]}.md
861             readarray -t test_tag_array <<< $(grep -v "#" \
862                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
863                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
864             SELECTION_MODE="--test"
865             ;;
866         * )
867             if [[ -z "${TEST_TAG_STRING-}" ]]; then
868                 # If nothing is specified, we will run pre-selected tests by
869                 # following tags.
870                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
871                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
872                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
873                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
874                                 "!dot1q" "!drv_avf")
875             else
876                 # If trigger contains tags, split them into array.
877                 test_tag_array=(${TEST_TAG_STRING//:/ })
878             fi
879             SELECTION_MODE="--include"
880             ;;
881     esac
882
883     # Blacklisting certain tags per topology.
884     #
885     # Reasons for blacklisting:
886     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
887     # TODO: Add missing reasons here (if general) or where used (if specific).
888     case "${TEST_CODE}" in
889         *"2n-skx"*)
890             test_tag_array+=("!ipsec")
891             ;;
892         *"3n-skx"*)
893             test_tag_array+=("!ipsechw")
894             # Not enough nic_intel-xxv710 to support double link tests.
895             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
896             ;;
897         *"2n-clx"*)
898             test_tag_array+=("!ipsec")
899             ;;
900         *"2n-zn2"*)
901             test_tag_array+=("!ipsec")
902             ;;
903         *"2n-dnv"*)
904             test_tag_array+=("!ipsechw")
905             test_tag_array+=("!memif")
906             test_tag_array+=("!srv6_proxy")
907             test_tag_array+=("!vhost")
908             test_tag_array+=("!vts")
909             test_tag_array+=("!drv_avf")
910             ;;
911         *"2n-tx2"*)
912             test_tag_array+=("!ipsechw")
913             ;;
914         *"3n-dnv"*)
915             test_tag_array+=("!memif")
916             test_tag_array+=("!srv6_proxy")
917             test_tag_array+=("!vhost")
918             test_tag_array+=("!vts")
919             test_tag_array+=("!drv_avf")
920             ;;
921         *"3n-tsh"*)
922             # 3n-tsh only has x520 NICs which don't work with AVF
923             test_tag_array+=("!drv_avf")
924             test_tag_array+=("!ipsechw")
925             ;;
926         *"3n-hsw"*)
927             test_tag_array+=("!drv_avf")
928             # All cards have access to QAT. But only one card (xl710)
929             # resides in same NUMA as QAT. Other cards must go over QPI
930             # which we do not want to even run.
931             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
932             ;;
933         *)
934             # Default to 3n-hsw due to compatibility.
935             test_tag_array+=("!drv_avf")
936             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
937             ;;
938     esac
939
940     # We will add excluded NICs.
941     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
942
943     TAGS=()
944     prefix=""
945
946     set +x
947     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
948         # Automatic prefixing for VPP jobs to limit the NIC used and
949         # traffic evaluation to MRR.
950         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
951             prefix="${prefix}mrrAND"
952         else
953             prefix="${prefix}mrrAND${default_nic}AND"
954         fi
955     fi
956     for tag in "${test_tag_array[@]}"; do
957         if [[ "${tag}" == "!"* ]]; then
958             # Exclude tags are not prefixed.
959             TAGS+=("${tag}")
960         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
961             # Badly formed tag expressions can trigger way too much tests.
962             set -x
963             warn "The following tag expression hints at bad trigger: ${tag}"
964             warn "Possible cause: Multiple triggers in a single comment."
965             die "Aborting to avoid triggering too many tests."
966         elif [[ "${tag}" == *"OR"* ]]; then
967             # If OR had higher precedence than AND, it would be useful here.
968             # Some people think it does, thus triggering way too much tests.
969             set -x
970             warn "The following tag expression hints at bad trigger: ${tag}"
971             warn "Operator OR has lower precedence than AND. Use space instead."
972             die "Aborting to avoid triggering too many tests."
973         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
974             # Empty and comment lines are skipped.
975             # Other lines are normal tags, they are to be prefixed.
976             TAGS+=("${prefix}${tag}")
977         fi
978     done
979     set -x
980 }
981
982
983 function select_topology () {
984
985     # Variables read:
986     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
987     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
988     # - CSIT_DIR - Path to existing root of local CSIT git repository.
989     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
990     # Variables set:
991     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
992     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
993     # Functions called:
994     # - die - Print to stderr and exit.
995
996     set -exuo pipefail
997
998     case_text="${NODENESS}_${FLAVOR}"
999     case "${case_text}" in
1000         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
1001         # TODO: Double link availability depends on NIC used.
1002         "1n_vbox")
1003             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1004             TOPOLOGIES_TAGS="2_node_single_link_topo"
1005             ;;
1006         "1n_skx" | "1n_tx2")
1007             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1008             TOPOLOGIES_TAGS="2_node_single_link_topo"
1009             ;;
1010         "2n_skx")
1011             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
1012             TOPOLOGIES_TAGS="2_node_*_link_topo"
1013             ;;
1014         "2n_zn2")
1015             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
1016             TOPOLOGIES_TAGS="2_node_*_link_topo"
1017             ;;
1018         "3n_skx")
1019             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
1020             TOPOLOGIES_TAGS="3_node_*_link_topo"
1021             ;;
1022         "2n_clx")
1023             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
1024             TOPOLOGIES_TAGS="2_node_*_link_topo"
1025             ;;
1026         "2n_dnv")
1027             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
1028             TOPOLOGIES_TAGS="2_node_single_link_topo"
1029             ;;
1030         "3n_dnv")
1031             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
1032             TOPOLOGIES_TAGS="3_node_single_link_topo"
1033             ;;
1034         "3n_hsw")
1035             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
1036             TOPOLOGIES_TAGS="3_node_single_link_topo"
1037             ;;
1038         "3n_tsh")
1039             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
1040             TOPOLOGIES_TAGS="3_node_single_link_topo"
1041             ;;
1042         "2n_tx2")
1043             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_tx2*.yaml )
1044             TOPOLOGIES_TAGS="2_node_single_link_topo"
1045             ;;
1046         *)
1047             # No falling back to 3n_hsw default, that should have been done
1048             # by the function which has set NODENESS and FLAVOR.
1049             die "Unknown specification: ${case_text}"
1050     esac
1051
1052     if [[ -z "${TOPOLOGIES-}" ]]; then
1053         die "No applicable topology found!"
1054     fi
1055 }
1056
1057
1058 function select_vpp_device_tags () {
1059
1060     # Variables read:
1061     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1062     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
1063     #   Can be unset.
1064     # Variables set:
1065     # - TAGS - Array of processed tag boolean expressions.
1066
1067     set -exuo pipefail
1068
1069     case "${TEST_CODE}" in
1070         # Select specific device tests based on jenkins job type variable.
1071         * )
1072             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1073                 # If nothing is specified, we will run pre-selected tests by
1074                 # following tags. Items of array will be concatenated by OR
1075                 # in Robot Framework.
1076                 test_tag_array=()
1077             else
1078                 # If trigger contains tags, split them into array.
1079                 test_tag_array=(${TEST_TAG_STRING//:/ })
1080             fi
1081             SELECTION_MODE="--include"
1082             ;;
1083     esac
1084
1085     # Blacklisting certain tags per topology.
1086     #
1087     # Reasons for blacklisting:
1088     # - avf - AVF is not possible to run on enic driver of VirtualBox.
1089     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
1090     case "${TEST_CODE}" in
1091         *"1n-vbox"*)
1092             test_tag_array+=("!avf")
1093             test_tag_array+=("!vhost")
1094             ;;
1095         *)
1096             ;;
1097     esac
1098
1099     TAGS=()
1100
1101     # We will prefix with devicetest to prevent running other tests
1102     # (e.g. Functional).
1103     prefix="devicetestAND"
1104     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1105         # Automatic prefixing for VPP jobs to limit testing.
1106         prefix="${prefix}"
1107     fi
1108     for tag in "${test_tag_array[@]}"; do
1109         if [[ ${tag} == "!"* ]]; then
1110             # Exclude tags are not prefixed.
1111             TAGS+=("${tag}")
1112         else
1113             TAGS+=("${prefix}${tag}")
1114         fi
1115     done
1116 }
1117
1118 function untrap_and_unreserve_testbed () {
1119
1120     # Use this as a trap function to ensure testbed does not remain reserved.
1121     # Perhaps call directly before script exit, to free testbed for other jobs.
1122     # This function is smart enough to avoid multiple unreservations (so safe).
1123     # Topo cleanup is executed (call it best practice), ignoring failures.
1124     #
1125     # Hardcoded values:
1126     # - default message to die with if testbed might remain reserved.
1127     # Arguments:
1128     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1129     # Variables read (by inner function):
1130     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1131     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1132     # Variables written:
1133     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1134     # Trap unregistered:
1135     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1136     # Functions called:
1137     # - die - Print to stderr and exit.
1138     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1139
1140     set -xo pipefail
1141     set +eu  # We do not want to exit early in a "teardown" function.
1142     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1143     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1144     if [[ -z "${wt-}" ]]; then
1145         set -eu
1146         warn "Testbed looks unreserved already. Trap removal failed before?"
1147     else
1148         ansible_playbook "cleanup" || true
1149         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1150             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1151         }
1152         WORKING_TOPOLOGY=""
1153         set -eu
1154     fi
1155 }
1156
1157
1158 function warn () {
1159
1160     # Print the message to standard error.
1161     #
1162     # Arguments:
1163     # - ${@} - The text of the message.
1164
1165     set -exuo pipefail
1166
1167     echo "$@" >&2
1168 }